//usb.h














///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////






typedef unsigned char	USB_U8;
typedef unsigned short	USB_U16;
typedef unsigned long	USB_U32;

typedef char			USB_S8;
typedef short		USB_S16;
typedef long			USB_S32;






///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////



/* terminal out mode */
#define	PRINT_USE				0
#define	PRINT_NOT_USE			1
//#define	PRINT_MODE				PRINT_USE
#define	PRINT_MODE				PRINT_NOT_USE



#define PBUS_WAIT 	 			1			/* CPU Bus Access Wait Specification */
#define BBUS_WAIT 	 			3			/* Dx_FIFO Bus Access Wait Specification */

#define	USBLVL					9			/* interrupt level USB */
#define	IRQLVL					9			/* interrupt level IRQ */
#define	DMACLVL					9			/* interrupt level DMAC */




/* User Data Buffer Size */
#define	P1_BUF_SIZE				512
#define	P2_BUF_SIZE				512
#define	P3_BUF_SIZE				512
#define	P4_BUF_SIZE				512
#define	P5_BUF_SIZE				512
#define	P6_BUF_SIZE				512
#define	P7_BUF_SIZE				512
#define	P8_BUF_SIZE				512
#define	P9_BUF_SIZE				512




#define	VENDOR_ID				0x5800				/* Vendor  ID */
#define	PRODUCT_ID				0x0050				/* Product ID */

#define	PIPEERR					3					/* Max pipe error count */




/* remote wakeup mode */
#define	RWUP_NOT_USE			0x00
#define	RWUP_USE				0x20				/* bmAttributes D5 bit */
#define	RWUP_MODE				RWUP_NOT_USE
//#define	RWUP_MODE				RWUP_USE





/* System Configuration Status Register */
/* SYSCFG */
#define	BITSCKE				( 0x0400u )	/* b10: USB clock enable */
#define	BITHSE				( 0x0080u )	/* b7: Hi-speed enable */
#define	BITDCFM				( 0x0040u )	/* b6: Controller function select  */
#define	BITDRPD				( 0x0020u )	/* b5: D- pull down control */
#define	BITDPRPU			( 0x0010u )	/* b4: D+ pull up control */
#define	BITUSBE				( 0x0001u )	/* b0: USB module operation enable */
#define BITBWAIT			( 0x000fu )	/* b3-0: CPU BUS access wait */


#define	HOST_CONTROLER		( 0x0040u )
#define	PERI_CONTROLER		( 0x0000u )



/* System Configuration Status Register */
/*LNST  b1-0: D+, D- line status */
#define	BITLNST				0x0003u		/* b1-b0: LNST */
#define	  SE1				 0x0003u	/* SE1 */
#define	  FS_KSTS			 0x0002u	/* Full-Speed K State */
#define	  FS_JSTS			 0x0001u	/* Full-Speed J State */
#define	  LS_JSTS			 0x0002u	/* Low-Speed J State */
#define	  LS_KSTS			 0x0001u	/* Low-Speed K State */
#define	  SE0				 0x0000u	/* SE0 */
#define	  CHIRPJ			 0x0001u	/* Chirp J */
#define	  CHIRPK			 0x0002u	/* Chirp J */


/* Device State Control Register */
/* DVSTCTR */
#define	BITWKUP				( 0x0100u )	/* b8: Remote wakeup */
#define	BITRWUPE			( 0x0080u )	/* b7: Remote wakeup sense */
#define	BITUSBRST			( 0x0040u )	/* b6: USB reset enable */
#define	BITRESUME			( 0x0020u )	/* b5: Resume enable */
#define	BITUACT				( 0x0010u )	/* b4: USB bus enable */
#define	BITRHST				( 0x0007u )	/* b1-0: Reset handshake status */
#define	  HSPROC			 0x0004u	/* HS handshake is processing */
#define	  HSMODE			 0x0003u	/* Hi-Speed mode */
#define	  FSMODE			 0x0002u	/* Full-Speed mode */
#define	  LSMODE			 0x0001u	/* Low-Speed mode */
#define	  UNDECID			 0x0000u	/* Undecided */


/* Test Mode Register */
/* TESTMODE */
/* UTST: Test select */
#define	  H_TST_FORCE		 0x000Du	/* HOST TEST Force */
#define	  H_TST_PACKET		 0x000Cu	/* HOST TEST Packet */
#define	  H_TST_SE0_NAK		 0x000Bu	/* HOST TEST SE0 NAK */
#define	  H_TST_K			 0x000Au	/* HOST TEST K */
#define	  H_TST_J			 0x0009u	/* HOST TEST J */
#define	  H_TST_NORMAL		 0x0000u	/* HOST Normal Mode */
#define	  P_TST_PACKET		 0x0004u	/* PERI TEST Packet */
#define	  P_TST_SE0_NAK		 0x0003u	/* PERI TEST SE0 NAK */
#define	  P_TST_K			 0x0002u	/* PERI TEST K */
#define	  P_TST_J			 0x0001u	/* PERI TEST J */
#define	  P_TST_NORMAL		 0x0000u	/* PERI Normal Mode */


/* DMA-FIFO Bus Configuration Register */
//D0FBCFG
//D1FBCFG
#define	DFACC_CYC			( 0x0000u )	/* cycle still */
#define DFACC_16			( 0x0001u )	/* 16byte */
#define DFACC_32			( 0x0002u )	/* 32byte */
#define	BITDFACC			( 0x3000u )	/* b13-b12: Bus Access mode */
#define		BITDFACC_CYC	( 0x0000u )	/* cycle still */
#define 	BITDFACC_16		( 0x1000u )	/* 16byte */
#define 	BITDFACC_32		( 0x2000u )	/* 32byte */


/* CFIFO/DxFIFO Port Select Register */
/* CFIFOSEL */
/* D0FIFOSEL */
/* D1FIFOSEL */
/* Big endian mode */
#define	  BYTE_LITTLE		  0x0000u	/* little dendian */
#define	  BYTE_BIG			  0x0001u	/* big endifan */





/* MBW: Maximum bit width for FIFO access */
#define	  MBW_8				 0x0000u	/*  8bit */
#define	  MBW_16			 0x0001u	/* 16bit */

//#define	  MBW_32			 0x0002u	/* 32bit */



#define	BITRCNT			( 0x8000u )		/*  b15:Read count mode */
#define	BITREW			( 0x4000u )		/*  b14:Buffer rewind */
#define	BITDCLRM		( 0x2000u )		/*  b13:DMA buffer clear mode */
#define	BITDREQE		( 0x1000u )		/*  b12:DREQ output enable */


//#define	BITMBW			( 0x0c00u )		/*  b11-b10:Maximum bit width for FIFO access */
//RX63NUSB08/16rbĝ
#define BITMBW			( 0x0400u )		/*  b10:Maximum bit width for FIFO access */
#define BITMBW_8			 0x0000u	/*  8bit */
#define BITMBW_16			 0x0400u	/* 16bit */


//RX63NUSB0BIGEND
#define BITBIGEND			( 0x0100u )




//#define	  BITMBW_32			 0x0800u	/* 32bit */




#define	BITBIGEND		( 0x0100u )		/*  b8:FIFO Big endian mode */
#define	  BITBYTE_LITTLE		  0x0000u	/* little dendian */
#define	  BITBYTE_BIG			  0x0100u	/* big endifan */



#define	BITISEL			( 0x0020u )		/*  b5:DCP FIFO port direction select */
#define	BITCURPIPE		( 0x000fu )		/*  b3-b0:PIPE select */

#define	CFIFO_DIR_OUT		( 0x0020u )
#define	CFIFO_DIR_IN		( 0x0000u )

/* CFIFO/DxFIFO Port Control Register */
/* CFIFOCTR */
/* D0FIFOCTR */
/* D1FIFOCTR */
#define	BITBVAL				( 0x8000u )	/* b15: Buffer valid flag */
#define	BITBCLR				( 0x4000u )	/* b14: Buffer clear */
#define	BITFRDY				( 0x2000u )	/* b13: FIFO ready */
#define	BITDTLN				( 0x0FFFu )	/* b11-0: FIFO received data length */

/* Interrupt Enable Register 0 */
/* INTENB0 */
#define	BITVBSE				( 0x8000u )	/* b15: VBUS interrupt */
#define	BITRSME				( 0x4000u )	/* b14: Resume interrupt */
#define	BITSOFE				( 0x2000u )	/* b13: Frame update interrupt */
#define	BITDVSE				( 0x1000u )	/* b12: Device state transition interrupt */
#define	BITCTRE				( 0x0800u )	/* b11: Control transfer stage */
										/*      transition interrupt */
#define	BITBEMPE			( 0x0400u )	/* b10: Buffer empty interrupt */
#define	BITNRDYE			( 0x0200u )	/* b9: Buffer not ready interrupt */
#define	BITBRDYE			( 0x0100u )	/* b8: Buffer ready interrupt */

/* Interrupt Enable Register 0 */
/* INTENB1 */
#define	BITBCHGE		( 0x4000u )	/*  b14:USB bus chenge interrupt( port0 ) */
#define	BITDTCHE		( 0x1000u )	/*  b12:Detach sense interrupt( port0 ) */
#define	BITATTCHE		( 0x0800u )	/*  b11:Attach sense interrupt( port0 ) */
#define	BITEOFERRE		( 0x0040u )	/*  b6:EOF error detect interrupt( port0 ) */
#define	BITSIGNE		( 0x0020u )	/*  b5:SETUP IGNORE interrupt( port0 ) */
#define	BITSACKE		( 0x0010u )	/*  b4:SETUP ACK interrupt( port0 ) */

/* SOF pin configration */
/* SOFCFG */
#define	BITTRNENSEL		( 0x0100u )	/*  b8:Transaction term-of-validity change */
#define	BITBRDYM		( 0x0040u )	/*  b6:BRDY interrupt status clear timeming change */



/* Interrupt Status Register 0 */
/* INTSTS0 */
/* DVSQ: Device state */
#define	BITVBINT			( 0x8000u )	/* b15: VBUS interrupt */
#define	BITRESM				( 0x4000u )	/* b14: Resume interrupt */
#define	BITSOFR				( 0x2000u )	/* b13: SOF frame update interrupt */
#define	BITDVST				( 0x1000u )	/* b12: Device state transition interrupt */
#define	BITCTRT				( 0x0800u )	/* b11: Control transfer stage */
										/*      transition interrupt */
#define	BITBEMP				( 0x0400u )	/* b10: Buffer empty interrupt */
#define	BITNRDY				( 0x0200u )	/* b9: Buffer not ready interrupt */
#define	BITBRDY				( 0x0100u )	/* b8: Buffer ready interrupt */
#define	BITVBSTS			( 0x0080u )	/* b7: VBUS input port */
#define	BITDVSQ				( 0x0070u )	/* b6-4: Device state */
#define	BITDVSQS			( 0x0030u )	/* b5-4: Device state */
#define	  DS_SPD_CNFG		 0x0070u	  /* Suspend Configured */
#define	  DS_SPD_ADDR		 0x0060u	  /* Suspend Address */
#define	  DS_SPD_DFLT		 0x0050u	  /* Suspend Default */
#define	  DS_SPD_POWR		 0x0040u	  /* Suspend Powered */
#define	  DS_SUSP			 0x0040u	  /* Suspend */
#define	  DS_CNFG			 0x0030u	  /* Configured */
#define	  DS_ADDS			 0x0020u	  /* Address */
#define	  DS_DFLT			 0x0010u	  /* Default */
#define	  DS_POWR			 0x0000u	  /* Powered */
#define	BITVALID			( 0x0008u )	/* b3: Setup packet detected flag */
#define	BITCTSQ				( 0x0007u )	/* b2-0: Control transfer stage */
#define	  CS_SQER			 0x0006u	  /* Sequence error */
#define	  CS_WRND			 0x0005u	  /* Control write nodata status stage */
#define	  CS_WRSS			 0x0004u	  /* Control write status stage */
#define	  CS_WRDS			 0x0003u	  /* Control write data stage */
#define	  CS_RDSS			 0x0002u	  /* Control read status stage */
#define	  CS_RDDS			 0x0001u	  /* Control read data stage */
#define	  CS_IDST			 0x0000u	  /* Idle or setup stage */


/* Interrupt Status Register 1 */
/* INTSTS1 */
#define	BITBCHG			( 0x4000u )	/*  b14:USB bus chenge interrupt( port0 ) */
#define	BITDTCH			( 0x1000u )	/*  b12:Detach sense interrupt( port0 ) */
#define	BITATTCH		( 0x0800u )	/*  b11:Attach sense interrupt( port0 ) */
#define	BITEOFERR		( 0x0040u )	/*  b6:EOF error detect interrupt( port0 ) */
#define	BITSIGN			( 0x0020u )	/*  b5:SETUP IGNORE interrupt( port0 ) */
#define	BITSACK			( 0x0010u )	/*  b4:SETUP ACK interrupt( port0 ) */


/* Frame number */
/* FRMNUM */
#define	BITOVRN			( 0x8000u )	/*  b15:Overrun error */
#define	BITCRCE			( 0x4000u )	/*  b14:Received data error */
#define	BITFRNM			( 0x03ffu )	/*  b10-b0:Frame number */


/* Buffer ready interrupt */
/* BRDYENB,BRDYSTS */
#define	BITBRDY9		( 0x0200u )		/* b9:PIPE9 */
#define	BITBRDY8		( 0x0100u )		/* b8:PIPE8 */
#define	BITBRDY7		( 0x0080u )		/* b7:PIPE7 */
#define	BITBRDY6		( 0x0040u )		/* b6:PIPE6 */
#define	BITBRDY5		( 0x0020u )		/* b5:PIPE5 */
#define	BITBRDY4		( 0x0010u )		/* b4:PIPE4 */
#define	BITBRDY3		( 0x0008u )		/* b3:PIPE3 */
#define	BITBRDY2		( 0x0004u )		/* b2:PIPE2 */
#define	BITBRDY1		( 0x0002u )		/* b1:PIPE1 */
#define	BITBRDY0		( 0x0001u )		/* b0:PIPE0 */


/* Buffer not ready interrupt */
/* NRDYENB,NRDYSTS */
#define	BITNRDY9		( 0x0200u )		/* b9:PIPE9 */
#define	BITNRDY8		( 0x0100u )		/* b8:PIPE8 */
#define	BITNRDY7		( 0x0080u )		/* b7:PIPE7 */
#define	BITNRDY6		( 0x0040u )		/* b6:PIPE6 */
#define	BITNRDY5		( 0x0020u )		/* b5:PIPE5 */
#define	BITNRDY4		( 0x0010u )		/* b4:PIPE4 */
#define	BITNRDY3		( 0x0008u )		/* b3:PIPE3 */
#define	BITNRDY2		( 0x0004u )		/* b2:PIPE2 */
#define	BITNRDY1		( 0x0002u )		/* b1:PIPE1 */
#define	BITNRDY0		( 0x0001u )		/* b0:PIPE0 */



/* Buffer empty interrupt */
/* BEMPENB,BEMPSTS */
#define	BITBEMP9		( 0x0200u )		/* b9:PIPE9 */
#define	BITBEMP8		( 0x0100u )		/* b8:PIPE8 */
#define	BITBEMP7		( 0x0080u )		/* b7:PIPE7 */
#define	BITBEMP6		( 0x0040u )		/* b6:PIPE6 */
#define	BITBEMP5		( 0x0020u )		/* b5:PIPE5 */
#define	BITBEMP4		( 0x0010u )		/* b4:PIPE4 */
#define	BITBEMP3		( 0x0008u )		/* b3:PIPE3 */
#define	BITBEMP2		( 0x0004u )		/* b2:PIPE2 */
#define	BITBEMP1		( 0x0002u )		/* b1:PIPE1 */
#define	BITBEMP0		( 0x0001u )		/* b0:PIPE0 */



/* u Frame number */
/* UFRMNUM */
#define	BITUFRNM		( 0x0007u )	/*  b2-b0:Micro frame number */



/* USB address */
/* USBADDR */
#define	BITUSBADDR		( 0x003fu )	/*  b6-b0:USB address */



/* USB Request Type Register */
/* USBREQ */
/* BMREQSTTYPE: RequestType */
#define	bRequest			( 0xFF00u )	/* b15-8: bRequest */
#define	bmRequestType		( 0x00FFu )	/* b7-0: bmRequestType */
#define	bmRequestTypeDir	( 0x0080u )	/* b7  : Data transfer direction */
#define	bmRequestTypeType	( 0x0060u )	/* b6-5: Type */
#define	bmRequestTypeRecip	( 0x001Fu )	/* b4-0: Recipient */



/* USB Request Value Register */
/* USBVAL */
#define	DT_TYPE				( 0xFF00u )
#define	DT_INDEX			( 0x00FFu )
#define	CONF_NUM			( 0x00FFu )
#define	ALT_SET				( 0x00FFu )
#define	GET_DT_TYPE( v )		( ( ( v ) & DT_TYPE ) >> 8 )



#define		wIndex				( 0xFFFFu )	/* b15-0: wIndex */
#define		TEST_SELECT			( 0xFF00u )	/* b15-b8: Test Mode Selectors */
#define	  TEST_J			 0x0100u	  /* Test_J */
#define	  TEST_K			 0x0200u	  /* Test_K */
#define	  TEST_SE0_NAK		 0x0300u	  /* Test_SE0_NAK */
#define	  TEST_PACKET		 0x0400u	  /* Test_Packet */
#define	  TEST_FORCE_ENABLE	 0x0500u	  /* Test_Force_Enable */
#define	  TEST_STSelectors	 0x0600u	  /* Standard test selectors */
#define	  TEST_Reserved		 0x4000u	  /* Reserved */
#define	  TEST_VSTModes		 0xC000u	  /* Vendor-specific test modes */
#define		EP_DIR				( 0x0080u )	/* b7: Endpoint Direction */
#define	  EP_DIR_IN			 0x0080u
#define	  EP_DIR_OUT		 0x0000u



/* default control pipe configration */
/* DCPCFG */
#define	BITDIR				( 0x0010u )	/*  b4:Control transfer DIR select */
#define	DCP_DIRBIT_OUT		1			/* DCP Out Direction					*/
#define	DCP_DIRBIT_IN		0			/* DCP In Direction						*/




/* default control pipe max packet size */
/* DCPMAXP */
#define	BITDCPDEVSEL			( 0xf000u )	/*  b15-b12:Device address select */
#define	BITDCPMXPS				( 0x007fu )	/*  b6-b0:Maxpacket size */
											/*        of default control pipe */





/* DEVSEL: Device address select */
#define	  DEVICE_0			 0x0000u	  /* Device address 0 */
#define	  DEVICE_1			 0x0001u	  /* Device address 1 */
#define	  DEVICE_2			 0x0002u	  /* Device address 2 */
#define	  DEVICE_3			 0x0003u	  /* Device address 3 */
#define	  DEVICE_4			 0x0004u	  /* Device address 3 */
#define	  DEVICE_5			 0x0005u	  /* Device address 3 */
#define	  DEVICE_6			 0x0006u	  /* Device address 3 */
#define	  DEVICE_7			 0x0007u	  /* Device address 3 */
#define	  DEVICE_8			 0x0008u	  /* Device address 3 */
#define	  DEVICE_9			 0x0009u	  /* Device address 3 */
#define	  DEVICE_10			 0x000Au	  /* Device address 3 */



/* default control pipe control */
/* DCPCTR */
/* PIPE1CTR-PIPE5CTR */
/* PIPE6CTR-PIPE9CTR */
#define	BITBSTS				( 0x8000u )	/*  b15:Buffer status */
#define	BITSUREQ			( 0x4000u )	/*  b14:Send setup taken */
#define	BITCSCLR			( 0x2000u )	/*  b13:Split Transaction status clear */
#define	BITCSSTS			( 0x1000u )	/*  b12:Split Transaction status */
#define	BITSUREQCLR			( 0x0800u )	/*  b11:Send USB request clear */
#define	BITSQCLR			( 0x0100u )	/*  b8:Sequence toggle bit clear */
#define	BITSQSET			( 0x0080u )	/*  b7:Sequence toggle bit set */
#define	BITSQMON			( 0x0040u )	/*  b6:Sequence toggle bit monitor */
#define	BITPBUSY			( 0x0020u )	/*  b5:pipe busy */
#define	BITPINGE			( 0x0010u )	/*  b4:Ping taken enable*/
#define	BITCCPL				( 0x0004u )	/*  b2:Enable control transfer complete */
#define	BITPID				( 0x0003u )	/*  b1-b0:Response PID */
#define	  PID_STALL2		 0x0003u	  /* STALL */
#define	  PID_STALL			 0x0002u	  /* STALL */
#define	  PID_BUF			 0x0001u	  /* BUF */
#define	  PID_NAK			 0x0000u	  /* NAK */


/* PIPE1CTR-PIPE5CTR */
#define	BITINBUFM			( 0x4000u )	/*  b14:IN buffer monitor */
#define	BITATREPM			( 0x0400u )	/*  b10:auto responce mode */
#define	BITACLRM			( 0x0200u )	/*  b9:Out buffer auto clear mode */

#define	DCP_DATA_TOGGLE0		( 0x0100u )
#define	DCP_DATA_TOGGLE1		( 0x0080u )
#define	DCP_DATA_TOGGLE1_PING	( 0x0090u )

#define	DCP_DIRBIT_OUT		1			/* DCP Out Direction					*/
#define	DCP_DIRBIT_IN		0			/* DCP In Direction						*/

/* pipe windows select */
/* PIPESEL */
#define	BITPIPESEL			( 0x000fu )	/*  b3-b0:Pipe select */

/* PIPEn configration */
/* PIPECFG */
#define		TYPFIELD			( 0xC000u )	/* b15-14: Transfer type */
#define		ISO				 0xC000u	  /* Isochronous */
#define		INT				 0x8000u	  /* Interrupt */
#define	  BULK				 0x4000u	  /* Bulk */

#define		BFREFIELD			( 0x0400u )	/* b10: Buffer ready interrupt mode select */
#define	  BFREON			 0x0400u
#define	  BFREOFF			 0x0000u


#define		DBLBFIELD			( 0x0200u )	/* b9: Double buffer mode select */
#define	  DBLBON			 0x0200u
#define	  DBLBOFF			 0x0000u
#define		CNTMDFIELD			( 0x0100u )	/* b8: Continuous transfer mode select */
#define	  CNTMDON			 0x0100u
#define	  CNTMDOFF			 0x0000u
#define		SHTNAKFIELD			( 0x0080u )	/* b7: Transfer end NAK */
#define	  SHTNAKON			 0x0080u
#define	  SHTNAKOFF			 0x0000u
#define		DIRFIELD			( 0x0010u )	/* b4: Transfer direction select */
#define	  DIR_H_OUT			 0x0010u	  /* HOST OUT */
#define	  DIR_P_IN			 0x0010u	  /* PERI IN */
#define	  DIR_H_IN			 0x0000u	  /* HOST IN */
#define	  DIR_P_OUT			 0x0000u	  /* PERI OUT */
#define		EPNUMFIELD			( 0x000Fu )	/* b3-0: Eendpoint number select */
#define		MAX_EP_NO			15u			/* EP0 EP1 ... EP15 */
#define	  EP0				 0x0000u
#define	  EP1				 0x0001u
#define	  EP2				 0x0002u
#define	  EP3				 0x0003u
#define	  EP4				 0x0004u
#define	  EP5				 0x0005u
#define	  EP6				 0x0006u
#define	  EP7				 0x0007u
#define	  EP8				 0x0008u
#define	  EP9				 0x0009u
#define	  EP10				 0x000Au
#define	  EP11				 0x000Bu
#define	  EP12				 0x000Cu
#define	  EP13				 0x000Du
#define	  EP14				 0x000Eu
#define	  EP15				 0x000Fu
#define	  BYTE_LITTLE		  0x0000u	/* little dendian */

/* PIPEn buffer select */
/* PIPEBUF */
#define	BITBUFSIZE			( 0x7c00u )	/*  b14-b10:Pipe buffer size */
#define	BITBUFNMB			( 0x00ffu )	/*  b7-b0:Pipe buffer number */
#define	PIPE0BUF			( 256u )
#define	PIPExBUF			( 64u )

/* PIPEn max packet size */
/* PIPEMAXP */
#define	BITDEVSEL			( 0xf000u )	/*  b15-b14:Pipe Device select */
#define	BITMXPS				( 0x07ffu )	/*  b10-b0:Pipe Maxpacket size */

/* PIPEn interval control */
/* PIPEPERI */
#define	BITIFIS				( 0x1000u )	/*  b12:Isochronous in-buffer */
										/*      flush mode select */
#define	BITIITV				( 0x0007u )	/*  b3-b0:Isochronous interval */


/* PIPEnCTR ( Only for PIPE1 to 5 ) */
/* PIPEnCTR ( Only for PIPE6 to 9 ) */
/* PIPEnTRE ( Only for PIPE1 to 5 ) */
/* PIPE1TRE-PIPE5TRE */

#define	BITTRENB			( 0x0020u )	/*  b9:Transaction counter enable */
#define	BITTRCLR			( 0x0010u )	/*  b8:Transaction counter clear */


#define DUMMY_ACCESS	(*(volatile unsigned long *)(0x20000000))



#define	BITUPPHUB			( 0x7800u )	/*  b14-11:target HUB address */
#define	BITHUBPORT			( 0x0700u )	/*  b10-8:target HUB port */
#define	BITUSBSPD			( 0x00c0u )	/*  b7-6:target Device speed */
#define USBSPD_NON			( 0x0000u )
#define USBSPD_LOW			( 0x0001u )
#define USBSPD_FUL			( 0x0002u )
#define USBSPD_HI			( 0x0003u )



#define CACHE_WRITEBACK

#define		LOCAL_Rev			"VER206_091221"


#define	BcdUsb					0x0200				/* bcdUSB */
#define	ReleaseNo				0x0101				/* Release Number */





#define		usb_enable		(USB.INTSTS0.BIT.DVSQ==3) 




#define		PIPE1_OUT			1
#define		PIPE2_IN			2
#define		PIPE3_OUT			3
#define		PIPE4_IN			4
#define		PIPE5_OUT			5
#define		PIPE6_IN			6
#define		PIPE7_OUT			7
#define		PIPE8_IN			8
#define		PIPE9_OUT			9



#define	MAX_PIPE_NO			9u

extern unsigned short	PipeFlag[ MAX_PIPE_NO + 1 ];
extern unsigned long	PipeDataSize[ MAX_PIPE_NO + 1 ];



//gUNVĂ邩
#define		PipeDone(Pipe)		(PipeFlag[Pipe] == PIPE_DONE)



//ۂɎM
#define		PipeRxLen(Pipe)	(PipeDataSize[Pipe])


#define	USB_ON							(1)
#define	USB_OFF							(0)
#define	USB_YES							(1)
#define USB_NO							(0)
#define	USB_SUCCESS						 0
#define	USB_ERROR						(-1)









#define	DT_DEVICE						(USB_U8)0x01	/* Configuration Descriptor */

#define	DT_CONFIGURATION				(USB_U8)0x02	/* Configuration Descriptor */

#define	DT_STRING						(USB_U8)0x03	/* Configuration Descriptor */
#define	DT_INTERFACE					(USB_U8)0x04	/* Interface Descriptor */
#define	DT_ENDPOINT						(USB_U8)0x05	/* Endpoint Descriptor */
#define	DT_DEVICE_QUALIFIER				(USB_U8)0x06	/* Device Qualifier Descriptor */
#define	DT_OTHER_SPEED_CONFIGURATION	(USB_U8)0x07	/* Other Speed Configuration Descriptor */
#define	DT_INTERFACE_POWER				(USB_U8)0x08	/* Interface Power Descriptor */




/* Device class Define  */

#define	DEVCLSINTF						(USB_U8)0x00	/* Class information at interface */
#define	DEVCLSCOMM						(USB_U8)0x02	/* Communication Device */
#define	DEVCLSHUB						(USB_U8)0x90	/* HUB Device */
#define	DEVCLSDIAG						(USB_U8)0xDC	/* Diagnostic Device */
#define	DEVCLSWIRE						(USB_U8)0xE0	/* Wireless Controller */
#define	DEVCLSAPL						(USB_U8)0xFE	/* Application-Specific */
#define	DEVCLSVEN						(USB_U8)0xFF	/* Vendor-Specific */




/* Interface class Define */

#define	INTFCLSNOT						(USB_U8)0x00	/* Un corresponding Class */
#define	INTFCLSAUD						(USB_U8)0x01	/* Audio Class */
#define	INTFCLSCDCC						(USB_U8)0x02	/* CDC-Control Class */
#define	INTFCLSHID						(USB_U8)0x03	/* HID Class */
#define	INTFCLSPHY						(USB_U8)0x05	/* Physical Class */
#define	INTFCLSIMG						(USB_U8)0x06	/* Image Class */
#define	INTFCLSPRN						(USB_U8)0x07	/* Printer Class */
#define	INTFCLSMAS						(USB_U8)0x08	/* Mass Storage Class */
#define	INTFCLSHUB						(USB_U8)0x09	/* HUB Class */
#define	INTFCLSCDCD						(USB_U8)0x0A	/* CDC-Data Class */
#define	INTFCLSCHIP						(USB_U8)0x0B	/* Chip/Smart Card Class */
#define	INTFCLSCNT						(USB_U8)0x0C	/* Content-Sequrity Class */
#define	INTFCLSVID						(USB_U8)0x0D	/* Video Class */
#define	INTFCLSDIAG						(USB_U8)0xDC	/* Diagnostic Device */
#define	INTFCLSWIRE						(USB_U8)0xE0	/* Wireless Controller */
#define	INTFCLSAPL						(USB_U8)0xFE	/* Application-Specific */
#define	INTFCLSVEN						(USB_U8)0xFF	/* Vendor-Specific Class */







/* USB Standard request */

#define	GET_STATUS						0x0000u
#define	CLEAR_FEATURE					0x0100u
#define	ReqRESERVED						0x0200u
#define	SET_FEATURE						0x0300u
#define	ReqRESERVED1					0x0400u
#define	SET_ADDRESS						0x0500u
#define	GET_DESCRIPTOR					0x0600u
#define	SET_DESCRIPTOR					0x0700u
#define	GET_CONFIGURATION				0x0800u
#define	SET_CONFIGURATION				0x0900u
#define	GET_INTERFACE					0x0A00u
#define	SET_INTERFACE					0x0B00u
#define	SYNCH_FRAME						0x0C00u
#define	HOST_TO_DEVICE					0x0000u
#define	DEVICE_TO_HOST					0x0080u
#define	STANDARD						0x0000u
#define	CLASS							0x0020u
#define	VENDOR							0x0040u
#define	DEVICE							0x0000u
#define	INTERFACE						0x0001u
#define	ENDPOINT						0x0002u



/* GET_STATUS request information */
/* Standard Device status */
#define	GS_BUSPOWERD					0x0000u
#define	GS_SELFPOWERD					0x0001u
#define	GS_REMOTEWAKEUP					0x0002u



/* Endpoint status */
#define	GS_NOTHALT						0x0000u
#define	GS_HALT							0x0001u




/* CLEAR_FEATURE/GET_FEATURE/SET_FEATURE request information */
/* Standard Feature Selector */

#define	ENDPOINT_HALT					0x0000u
#define	DEVICE_REMOTE_WAKEUP			0x0001u
#define	TEST_MODE						0x0002u




/* GET_DESCRIPTOR/SET_DESCRIPTOR request information */
/* Standard Descriptor type */

#define	DEVICEDESCRIPTOR						0x0100u
#define	CONFIGURATIONDESCRIPTOR					0x0200u
#define	STRINGDESCRIPTOR						0x0300u
#define	INTERFACEDESCRIPTOR						0x0400u
#define	ENDPOINTDESCRIPTOR						0x0500u
#define	DEVICE_QUALIFIERDESCRIPTOR				0x0600u
#define	OTHER_SPEED_CONFIGURATIONDESCRIPTOR		0x0700u
#define	INTERFACE_POWERDESCRIPTOR				0x0800u






/* Pipe define */

#define	MAX_PIPE_NO			9u					/* PIPE0 ... PIPE9 */
#define	PIPE0				(USB_U16)0x0000		/* PIPE 0 */
#define	PIPE1				(USB_U16)0x0001		/* PIPE 1 */
#define	PIPE2				(USB_U16)0x0002		/* PIPE 2 */
#define	PIPE3				(USB_U16)0x0003		/* PIPE 3 */
#define	PIPE4				(USB_U16)0x0004		/* PIPE 4 */
#define	PIPE5				(USB_U16)0x0005		/* PIPE 5 */
#define	PIPE6				(USB_U16)0x0006		/* PIPE 6 */
#define	PIPE7				(USB_U16)0x0007		/* PIPE 7 */
#define	PIPE8				(USB_U16)0x0008		/* PIPE 8 */
#define	PIPE9				(USB_U16)0x0009		/* PIPE 9 */
#define	NOPIPE			 	(USB_U16)0x00FF		/* Undecided pipe number */
#define	USEPIPE			 	(USB_U16)0x00FE


#define	EPL					5u					/* Pipe configuration table length */

#define USB_NONE			(0u)

/* ----- Pipe Status ----- */

#define	PIPE_IDLE					0x00
#define	PIPE_WAIT					0x01
#define	PIPE_DONE					0x02
#define	PIPE_NORES					0x03
#define	PIPE_STALL					0x04
#define	PIPE_ERROR					0x05

#define	BUF_READY					0
#define	BUF_BUSY					1

#define	NON_SPEED					(0)
#define	LOW_SPEED					(1)
#define	FULL_SPEED					(2)
#define	HI_SPEED					(3)

#define	FIFO_USE					0x7000
#define	C_FIFO_USE					0x0000
#define	D0_FIFO_USE					0x1000
#define	D1_FIFO_USE					0x2000
#define	D0_FIFO_DMA					0x5000
#define	D1_FIFO_DMA					0x6000

#define	USB_BUF2FIFO				0
#define	USB_FIFO2BUF				1

#define	BUF_SIZE(x)			(USB_U16)((USB_U16)(((x) / 64) - 1) << 10)
#define	BUF_NUMB(x)			(USB_U16)(x)

/* Device connect information */

#define	ATTACH				(USB_U16)0x01
#define	DETACH				(USB_U16)0x00

/* FIFO port & access define */

#define	CUSE				(USB_U16)0		/* CFIFO CPU transfer */
#define	D0USE				(USB_U16)1		/* D0FIFO CPU transfer */
#define	D0DMA				(USB_U16)2		/* D0FIFO DMA transfer */
#define	D1USE				(USB_U16)3		/* D1FIFO CPU transfer */
#define	D1DMA				(USB_U16)4		/* D1FIFO DMA transfer */




/* ----- DeviceState ----- */
#define	DVST_DETACHED				0x0000
#define	DVST_ATTACHED				0x0001
#define	DVST_GET_DESCRIPTOR_64		0x0002
#define	DVST_POWERED				0x0003
#define	DVST_DEFAULT				0x0004
#define	DVST_SET_ADDRESS			0x0005
#define	DVST_ADDRESS				0x0006
#define	DVST_GET_DESCRIPTOR_18		0x0007
#define	DVST_GET_DESCRIPTOR_9		0x0008
#define	DVST_GET_DESCRIPTOR_SIZE	0x0009
#define	DVST_SET_PIPE				0x000A
#define	DVST_SET_CONFIGURATION		0x000B
#define	DVST_CONFIGURED				0x000C
#define	DVST_DETACH_CHK				0x000D
#define	DVST_SUSPEND				0x1000
#define	DVST_NORES					0x0100
#define	DVST_STALL					0x0200

#define	DVST_POWERED_SUSPEND		(DVST_SUSPEND | DVST_POWERED)
#define	DVST_DEFAULT_SUSPEND		(DVST_SUSPEND | DVST_DEFAULT)
#define	DVST_ADDRESS_SUSPEND		(DVST_SUSPEND | DVST_ADDRESS)
#define	DVST_CONFIGURED_SUSPEND		(DVST_SUSPEND | DVST_CONFIGURED)




/* Configuration Descriptor  DEFINE */
#define	CF_RESERVED					0x80			/* Reserved(set to 1) */
#define	CF_SELF						0x40			/* Self Powered */
#define	CF_RWUP						0x20			/* Remote Wakeup */


/* Endpoint Descriptor	DEFINE */
#define	EP_DIR_MASK					0x80			/* Endpoint Direction	*/
#define	EP_OUT						0x00			/* Out Endpoint */
#define	EP_IN						0x80			/* In  Endpoint */
#define	EP_CNTRL					0x00			/* Control	   Transfer */
#define	EP_ISO						0x01			/* Isochronous Transfer */
#define	EP_BULK						0x02			/* Bulk		   Transfer */
#define	EP_INT						0x03			/* Interrupt   Transfer */
#define	EP_TYPE						0x03			/* Transfer    Type		*/
#define	EP_NUM_MASK					0x0F			/* Endpoint Direction	*/



#define	DEV_MAX_PKT_SIZE			7				/* index of bMAXPacketSize */

#define	DEV_NUM_CONFIG				17				/* index of bNumConfigurations */

#define	ALT_NO						255

#define	EP_ERROR					0xFF
#define	SOFTWARE_CHANGE				0





/* FIFO read / write result */

#define	FIFOERROR	(USB_U16)USB_ERROR				/* FIFO not ready */
#define	WRITEEND	(USB_U16)0x00		/* end of write ( but packet may not be outputting ) */
#define	WRITESHRT	(USB_U16)0x01		/* end of write ( send short packet ) */
#define	WRITING		(USB_U16)0x02		/* write continues */
#define	WRITEDMA	(USB_U16)0x03		/* DMA write  */
#define	READEND		(USB_U16)0x00		/* end of read */
#define	READSHRT	(USB_U16)0x01		/* insufficient ( receive short packet ) */
#define	READING		(USB_U16)0x02		/* read continues */
#define	READOVER	(USB_U16)0x03		/* buffer size over */




/* ----- UsbCmdStage State ----- */

#define	CMD_IDLE					0x0000
#define	CMD_DOING					0x0001
#define	CMD_DONE					0x0002
#define	CMD_NORES					0x0003
#define	CMD_STALL					0x0004
#define	CMD_FIELD					0x000F
#define	CHG_CMD_FIELD( r, v )		do { r &= ( ~CMD_FIELD );	\
										 r |= v;				} while(0)

#define	MODE_WRITE					0x0100
#define	MODE_READ					0x0200
#define	MODE_NO_DATA				0x0300
#define	MODE_FIELD					0x0F00
#define	CHG_MODE_FIELD( r, v )		do { r &= ( ~MODE_FIELD );	\
										 r |= v;				} while(0)

#define	STAGE_SETUP					0x0010
#define	STAGE_DATA					0x0020
#define	STAGE_STATUS				0x0030
#define	STAGE_FIELD					0x00F0
#define	CHG_STAGE_FIELD( r, v )		do { r &= ( ~STAGE_FIELD );	\
										 r |= v;				} while(0)



/* Type Declaration for DMA control user defined function argument 		*/
#define	USB_D0FIFO 			0
#define	USB_D1FIFO 			1
#define	USB_DMA_READY 		0
#define	USB_DMA_BUSY 		1




///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////



/* DEVADDn ( n=0-A ) */
/* DEVADD0-DEVADDA */
typedef union {						/* DEVADDn ( n=0-A ) */
	USB_U16 WORD;					/*  Word Access */
	struct {
		USB_U16 :1;
		USB_U16 UPPHUB:4;			/*  b14-11:target HUB address */
		USB_U16 HUBPORT:3;			/*  b10-8:target HUB port */
		USB_U16 USBSPD:2;			/*  b7-6:target Device speed */
		USB_U16 :6;
	} BIT;
}DEVADD;





typedef struct {
	USB_U16				pipe_number;
	USB_U16				pipe_cfg;
	USB_U16				pipe_buf;
	USB_U16				pipe_max_pktsize;
	USB_U16				pipe_cycle;
	USB_U16				fifo_port;
} USB_CFG_PIPETBL;


typedef struct{
	USB_U32 fifo;//FIFO
	USB_U32 buffer;//buffer address
	USB_U32 bytes;//data byte
	USB_U32 dir;//direction
	USB_U32 size;//size per 1 DMA transfer
}USB_DMA;





//ǉ

typedef struct{
	void (*pc)(void);		//
	_UDWORD param1;
}USB_READ_DEND_INT_CMD;








///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

extern USB_U16 PipeIgnore[];					/* Ignore count */
extern USB_U16 PipeTbl[];
extern USB_U16 PipeFlag[];
extern USB_U32 PipeDataSize[];

extern USB_U8 DeviceDescriptor[];
extern USB_U8 QualifierDescriptor[];
extern USB_U8 Configuration_Full_1[];
extern USB_U8 Configuration_Full_2[];
extern USB_U8 Configuration_Full_3[];
extern USB_U8 Configuration_Full_4[];
extern USB_U8 Configuration_Full_5[];
extern USB_U8 Configuration_Hi_1[];
extern USB_U8 Configuration_Hi_2[];
extern USB_U8 Configuration_Hi_3[];
extern USB_U8 Configuration_Hi_4[];
extern USB_U8 Configuration_Hi_5[];

extern USB_U8 *ConPtr[];
extern USB_U8 *ConPtr_Other[];
extern USB_U8 StringDescriptor0[];
extern USB_U8 StringDescriptor1[];
extern USB_U8 StringDescriptor2[];
extern USB_U8 *StrPtr[];

extern USB_U32 USBDataCount[];			/* PIPEn Buffer counter */
extern USB_U32 USBRcvDataCount[];		/* PIPEn receive data counter */
extern USB_U8 *USBDataPointer[];		/* PIPEn Buffer pointer */
extern USB_U16 ConfigNum;				/* configuration Number */
extern const USB_U16 BitSet[];
extern USB_DMA USBDmaInfo[];		/* DMA Setting Infomation */
extern USB_U16 USBDmaPipe[];		/* DMA Transfar Pipe */
extern USB_U16 USBDmaVal[];		/* VAL(FIFOCTR) set flag after dma end */
extern USB_U16 USBDmaStatus[];

extern void (*pbRequest0[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);
extern void (*pbRequest1[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);
extern void (*pbRequest2[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);
extern void (*pbRequest3[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);
extern void (*pbRequest4[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);
extern void (*pbRequest5[])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length);

extern USB_U16 Alternate[];
extern USB_U16 RemoteWakeupFlag;  /* Remote Wakeup Enable Flag */
extern USB_U16 TestModeFlag;
extern USB_U16 TestModeSelectors;
extern USB_U16 EPTableIndex[];  	/* Index of EP Information table */
extern USB_U16 ReqType;   /* request type */
extern USB_U16 ReqTypeType;  	/* request type TYPE */
extern USB_U16 ReqTypeRecip;  	/* request type RECIPIENT */
extern USB_U16 ReqRequest;   /* request */
extern USB_U16 ReqValue;   /* value */
extern USB_U16 ReqIndex;   /* index */
extern USB_U16 ReqLength;  		/* length */



extern const USB_READ_DEND_INT_CMD usb_pipe_tb[10]; //ǉ



///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////






void usb_start_recieve_trns_c(USB_U16 pipe, USB_U32 size, USB_U8 *data);
void usb_start_recieve_trns_d0(USB_U16 pipe, USB_U32 size, USB_U8 *data);
void usb_start_recieve_trns_d1(USB_U16 pipe, USB_U32 size, USB_U8 *data);
void usb_start_recieve_dma_d0(USB_U16 pipe, USB_U32 size, USB_U8 *data);
void usb_start_recieve_dma_d1(USB_U16 pipe, USB_U32 size, USB_U8 *data);
USB_U16 usb_read_dma_d0(USB_U16 pipe);
USB_U16 usb_read_dma_d1(USB_U16 pipe);
USB_U16 usb_write_dma_d0(USB_U16 pipe);
USB_U16 usb_write_dma_d1(USB_U16 pipe);
void usb_read_c_fifo(USB_U16 pipe,USB_U16 count);
void usb_write_c_fifo(USB_U16 Pipe,USB_U16 count);
void usb_read_d0_fifo(USB_U16 pipe,USB_U16 count);
void usb_write_d0_fifo(USB_U16 pipe,USB_U16 count);
void usb_read_d1_fifo(USB_U16 pipe,USB_U16 count);
void usb_write_d1_fifo(USB_U16 pipe,USB_U16 count);
void usb_clear_transaction_counter(USB_U16 pipe);
void usb_set_transaction_counter(USB_U16 pipe, USB_U32 count);
USB_U32	usb_com_get_dmasize(USB_U32 trncount,USB_U32 dtptr);

static void usb_dmaint(USB_U16 fifo); 
static void usb_dmaint_buf2fifo(USB_U16 pipe);
static void usb_dmaint_fifo2buf(USB_U16 pipe);
static void usb_enable_dmac0(USB_U32 src,USB_U32 dst,USB_U32 count,USB_U32 size,USB_U32 dir,USB_U32 fifo);
static void usb_enable_dmac1(USB_U32 src,USB_U32 dst,USB_U32 count,USB_U32 size,USB_U32 dir,USB_U32 fifo);
static void clear_pipe_tbl(void);
static void clear_ep_table_index(void);

USB_U16 usb_write_buffer(USB_U16 pipe);
USB_U16 usb_write_buffer_c(USB_U16 pipe);
USB_U16 usb_write_buffer_d0(USB_U16 pipe);
USB_U16 usb_write_buffer_d1(USB_U16 pipe);
USB_U16 usb_read_buffer(USB_U16 pipe);
USB_U16 usb_read_buffer_c(USB_U16 pipe);
USB_U16 usb_read_buffer_d0(USB_U16 pipe);
USB_U16 usb_read_buffer_d1(USB_U16 pipe);
USB_U16 usb_change_fifo_port(USB_U16 pipe, USB_U16 fifosel,USB_U16 isel, USB_U16 mbw);
void usb_set_curpipe(USB_U16 pipe, USB_U16 fifosel, USB_U16 isel, USB_U16 mbw);
USB_U16 usb_get_mbw(USB_U32 trncount,USB_U32 dtptr);
USB_U16 usb_read_dma(USB_U16 pipe);
void usb_stop_transfer( USB_U16 pipe );
void usb_init_mem(void);
void	usb_brdy_int(USB_U16 status, USB_U16 int_enb);
void	usb_nrdy_int(USB_U16 status, USB_U16 int_enb);
void	usb_bemp_int(USB_U16 status, USB_U16 int_enb);
void	usb_set_int_level(USB_U8 level);
void	usb_reset_module(void);
USB_U16 usb_get_mxps(USB_U16 pipe);
void usb_enable_brdy_int(USB_U16 pipe);
void usb_disable_brdy_int(USB_U16 pipe);
void usb_enable_bemp_int(USB_U16 pipe);
void usb_disable_bemp_int(USB_U16 pipe);
void usb_enable_nrdy_int(USB_U16 pipe);
void usb_disable_nrdy_int(USB_U16 pipe);
USB_U16 usb_is_hispeed( void);
USB_U16 usb_is_hispeed_enable( void );
void usb_set_pid_buf(USB_U16 pipe);
void usb_set_pid_nak(USB_U16 pipe);
void usb_set_pid_stall(USB_U16 pipe);
void usb_clear_pid_stall(USB_U16 pipe);
void usb_set_sqclr(USB_U16 pipe);
void usb_set_sqset(USB_U16 pipe);
void usb_set_csclr(USB_U16 pipe);
void usb_aclrm(USB_U16 pipe);
void usb_set_aclrm(USB_U16 pipe,USB_U16 set);
USB_U16 usb_get_sqmon( USB_U16 pipe );
void	P_Class0(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Class1(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Class2(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Class3(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Class4(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Class5(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor0(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor1(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor2(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor3(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor4(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
void	P_Vendor5(USB_U16 Reqtype, USB_U16 Request, USB_U16 Value, USB_U16 Index, USB_U16 Length);
USB_U16 P_CtrlReadStart(USB_U32 size, USB_U8 *data);
void	P_CtrlWriteStart(USB_U32 size, USB_U8 *data);
void	P_BRDYInterrupt(USB_U16 status, USB_U16 intenb);
void	P_NRDYInterrupt(USB_U16 status, USB_U16 intenb);
void	P_BEMPInterrupt(USB_U16 status, USB_U16 intenb);
void	P_ResetDCP(void);
void	P_ResetEP(USB_U16 num);
void	P_ResetDeviceDescriptor(USB_U16 mode);
void	P_EnableINTModule(void);
USB_U16 P_IsConfigured(void);
USB_U16 P_GetDeviceState(void);
USB_U16 P_EpToPipe(USB_U16 ep);
USB_U16 P_GetConfigNum(void);
USB_U16 P_GetInterfaceNum(USB_U16 num);
USB_U16 P_GetAltNum(USB_U16 Con_Num, USB_U16 Int_Num);
void	P_InitEPTable(USB_U16 Con_Num, USB_U16 Int_Num, USB_U16 Alt_Num);
USB_U16 P_CheckRemoteWakeup(void);
void	P_GetStatus(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_GetDescriptor(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_GetConfiguration(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_GetInterface(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
USB_U8	P_GetCurrentPower(USB_U16 ConfigNum);
void	P_Resrv_0(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_Resrv_123(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_Resrv_4(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_Resrv_5(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_ClearFeature(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SetFeature(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SetAddress(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SetDescriptor(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SetConfiguration(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SetInterface(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	P_SynchFrame(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length);
void	usb_clear_alt(void);
void	P_ChangeConfigCB(USB_U16 Con_Num);
void	P_ChangeInterfaceCB(USB_U16 Con_Num, USB_U16 Int_Num, USB_U16 Alt_Num);
void	P_SaveRequest(void);
USB_U16 P_CheckVBUStaus(void);
void	P_USBAttachCB(void);
void	P_USBDetachCB(void);
void	P_USBBusResetCB(void);
void	P_USBResumeCB(void);
void	P_USBSuspendCB(void);
void	P_USBTestModeCB(void);
void	usb_delay_1ms(void);
void	usb_delay_xms(USB_U32 msec);
void	usb_delay_10us(USB_U32 usec);
void	usb_userdef_clear_dmaint(void);
void	usb_userdef_start_dma(USB_DMA *dma);
USB_U32	usb_userdef_stop_dma0(void);
USB_U32	usb_userdef_stop_dma1(void);
void	usb_dma_stop_d0( USB_U16 pipe, USB_U32 remain );
void	usb_dma_stop_d1( USB_U16 pipe, USB_U32 remain );
USB_U16 usb_get_bus_speed(void);
void	usb_start_recieve_transfer(USB_U16 Pipe, USB_U32 Bsize, USB_U8 *Tbl);
USB_U16 usb_start_send_transfer(USB_U16 Pipe, USB_U32 Bsize, USB_U8 *Tbl);
USB_U16 usb_get_pid(USB_U16 pipe);
USB_U16 P_GetDeviceState(void);
void	P_UserApplication(void);







///////////////////////////////////////////////////////////////////////
//USB
///////////////////////////////////////////////////////////////////////
void	P_ModeInit(void);
///////////////////////////////////////////////////////////////////////
//USB
///////////////////////////////////////////////////////////////////////







///////////////////////////////////////////////////////////////////////
//テ[U[
///////////////////////////////////////////////////////////////////////
void USB_PIPE_0_(void);
void USB_PIPE_1_(void);
void USB_PIPE_2_(void);
void USB_PIPE_3_(void);
void USB_PIPE_4_(void);
void USB_PIPE_5_(void);
void USB_PIPE_6_(void);
void USB_PIPE_7_(void);
void USB_PIPE_8_(void);
void USB_PIPE_9_(void);
///////////////////////////////////////////////////////////////////////
//テ[U[
///////////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////////
//荞݃nh
///////////////////////////////////////////////////////////////////////
void USB0_D0FIFO0(void);
void USB0_D1FIFO0(void);
void USB0_USBI0(void);
void DMAC_DMAC1I(void);
void DMAC_DMAC0I(void);
///////////////////////////////////////////////////////////////////////
//荞݃nh
///////////////////////////////////////////////////////////////////////








